##########  YOU MUST KEEP THIS COPYRIGHTS NOTICE INTACT ###############
# Copyright  1997-2000 DCScripts All Rights Reserved
# As part of the installation process, you will be asked
# to accept the terms of this Agreement. This Agreement is
# a legal contract, which specifies the terms of the license
# and warranty limitation between you and DCScripts and DCLinks.
# You should carefully read the following terms and conditions before
# installing or using this software.  Unless you have a different license
# agreement obtained from DCScripts, installation or use of this software
# indicates your acceptance of the license and warranty limitation terms
# contained in this Agreement. If you do not agree to the terms of this
# Agreement, promptly delete and destroy all copies of the Software.
#
# 
# License to Redistribute
# --------------------------------------------------------------------------
# Distributing the software and/or documentation with other products
# (commercial or otherwise) or by other than electronic means without
# DCScripts's prior written permission is forbidden.
#
# All rights to the DCLinks software and documentation not expressly
# granted under this Agreement are reserved to DCScripts.
#
# Disclaimer of Warranty
# THIS SOFTWARE AND ACCOMPANYING DOCUMENTATION ARE PROVIDED "AS IS" AND
# WITHOUT WARRANTIES AS TO PERFORMANCE OF MERCHANTABILITY OR ANY OTHER
# WARRANTIES WHETHER EXPRESSED OR IMPLIED.   BECAUSE OF THE VARIOUS HARDWARE
# AND SOFTWARE ENVIRONMENTS INTO WHICH HKDBOARD MAY BE USED, NO WARRANTY OF
# FITNESS FOR A PARTICULAR PURPOSE IS OFFERED.  THE USER MUST ASSUME THE
# ENTIRE RISK OF USING THIS PROGRAM.  ANY LIABILITY OF DCSCRIPTS WILL BE
# LIMITED EXCLUSIVELY TO PRODUCT REPLACEMENT OR REFUND OF PURCHASE PRICE.
# IN NO CASE SHALL DCSCRIPTS BE LIABLE FOR ANY INCIDENTAL, SPECIAL OR
# CONSEQUENTIAL DAMAGES OR LOSS, INCLUDING, WITHOUT LIMITATION, LOST PROFITS
# OR THE INABILITY TO USE EQUIPMENT OR ACCESS DATA, WHETHER SUCH DAMAGES ARE
# BASED UPON A BREACH OF EXPRESS OR IMPLIED WARRANTIES, BREACH OF CONTRACT,
# NEGLIGENCE, STRICT TORT, OR ANY OTHER LEGAL THEORY. THIS IS TRUE EVEN IF
# DCSCRIPTS IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. IN NO CASE WILL
# DCSCRIPT'S LIABILITY EXCEED THE AMOUNT OF THE LICENSE FEE ACTUALLY PAID
# BY LICENSEE TO DCSCRIPTS.
#
###########################################################################

#======================================================================#
# get_session                                                          #
# Gets user data from the session file                                 #
#======================================================================#

sub get_session {
   my $r_temp = {};
   my $session = get_cookie($r_in->{'cookie_name'});
   if ($session) {
      if (-e "$datadir/$session.session") {
         $r_temp = get_userdata("$datadir/$session.session");
      }
      else {
         send_cookie($cookie_name,'','Thur, 31-Dec-98 12:00:00 GMT','');
         $session = '';
      }
   }

   return $r_temp;
}

#======================================================================#
# get_userdata                                                         #
# Gets user data from the session file                                 #
#======================================================================#

sub get_userdata {

   my ($session_file) = @_;
   my $r_data = readdata($session_file);
   my $r_local = {};
   
   foreach (@{$r_data}) {
      chomp;
      ($key,$value) = split(/::/,$_);
      $r_local->{$key} = $value;
   }

   return $r_local;

}


#======================================================================#
# subroutine send_mail
# REVISION
# 29 Dec 1998
#   Added Blatmail for NT servers
# 17 Mar 1998 - Version 1.0
#   First release
#
# NOTE:
#   Following variables are global
#   $smtp_server
#
#======================================================================#

sub send_mail {

   my ($dir,$mailprog,$from,$to,$subject,$message) = @_;

   unless ($platform eq 'NT') {  
      open(MAIL,"|$mailprog -t") or
         my_die("Error in subroutine send_mail: Can't open $mailprog",$!);
      print MAIL "To: $to\n";
     print MAIL "From: $from\n";
      print MAIL "Subject: $subject\n\n";
      print MAIL "$message\n";
      close (MAIL);
   }
   else {
      #prepare mail message to send
      #Following lines uses blatmail
#     my (@output,$status);
#     my $temp_name = get_session_id();
#     my $temp_file = "$dir/$temp_name.emn";
#     $output[0] = $message;
#     writedata($temp_file,\@output);
#     $status = `$mailprog $temp_file -s \"$subject\" -f $from -t $to -server $smtp_server`;
#     unlink($temp_file);

# prepare mail message to send
# Hack for Win NT and UNIX that opens a smtp socket
# Hack submitted by 
        ($x,$x,$x,$x, $here) = gethostbyname($null);
        ($x,$x,$x,$x, $there) = gethostbyname($smtp_server);
        $thisserver = pack('S n a4 x8',2,0,$here);
        $remoteserver = pack('S n a4 x8',2,25,$there);
        (!(socket(S,2,1,6))) && (my_die("Sending Email: Connect error! socket",$!));
        (!(bind(S,$thisserver))) && (my_die("Sending Email: Connect error! bind",$!));
        (!(connect(S,$remoteserver))) && (my_die("Sending Email: Connection to $smtp_server has failed ",$!));

        select(S);
        $| = 1;
        select(STDOUT);

        $DATA_IN = <S>;
        ($DATA_IN !~ /^220/) && (my_die("Sending Email: data in Connect error - 220",$!)); 

        print S "HELO $smtp_server\r\n";
        $DATA_IN = <S>;
        ($DATA_IN !~ /^250/) && (my_die("Sending Email: data in Connect error - 250",$!)); 

        print S "MAIL FROM:<$from>\r\n";
        $DATA_IN = <S>;
        ($DATA_IN !~ /^250/) && (my_die("Sending Email: 'From' address not valid",$!)); 

        print S "RCPT TO:<$to>\r\n";
        $DATA_IN = <S>;
        ($DATA_IN !~ /^250/) && (my_die("Sending Email: 'Recipient' address not valid",$!)); 

        print S "DATA\n";
        $DATA_IN = <S>;
        ($DATA_IN !~ /^354/) && (my_die("Sending Email: Message send failed - 354",$!)); 

        print S "From: $from\n";
        print S "To: $to\n";
        print S "Subject: $subject\n\n";
        print S "$message\n";

        print S <<MESSAGES;
.
MESSAGES

        $DATA_IN = <S>;
        ($DATA_IN !~ /^250/) && (my_die("Sending Email: Message send failed - try again - 250",$!)); 
        print S "QUIT\n";

   }

}

#####
#
#   subroutine get_setup_variables
#   displays the form for creating a new forum
#
#####

sub get_setup_variables {
  my($datafile,$r_in) = @_;
  $r_rows = readdata("$datafile");   
  foreach (@$r_rows) {
    chomp;
    ($key,$value) = split /\|/;
    $r_in->{$key} = $value;
  }
}

#####
#
# subroutine my_crypt
# encrpytion routine...rather simple one
# 
#####

sub my_crypt {
  my ($arg1, $arg2) = @_;
  unless ($platform eq "NT") {
	  $arg1 = crypt($arg1,substr($arg2,0,2));
  }
  $arg1;
}

#======================================================================#
# display_output                                                       #
#======================================================================#

sub display_output {
	print_header();
	print_header_end();
	my %name = (
     MENU => $menu,
     TITLE => $header,
     HEADER => $header,
     SUBHEADER => $sub_header,
     HTMLOUTPUT => $html_output
	);

	# Open template and read in
	open(TEMPLATE,"$booktemplate") or my_die("can't open $booktemplate",$!); {
   	 local($/) = undef;
    	$template = <TEMPLATE>;
	}
	close(TEMPLATE);  
	$template =~ s/\$([A-Z]+)/$name{$1}/g;
	print $template;
	exit(0);
}


#======================================================================#
# check_datafile                                                       #
# checks to see if data file exists                                    #
#======================================================================#

sub check_datafile {
   my($datafile,$r_variables) = @_;
   unless (-e $datafile) {
      open(FILE,">$datafile") or
         my_die("Error in subroutine check_datafile in dclib.pl: Can't open $datafile",$!);
	      foreach (@$r_variables) {
				chomp;
   	      print FILE "$_\n";
      	}
      close(FILE);
      chmod(0666,$datafile);
   }
}

#======================================================================#
# subroutine get_date
# modified to work with dcboard
#======================================================================#

sub get_date {
   my ($r_in) = @_;
   my @months = qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec);
   my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = gmtime(time+3600*$time_offset);
   # Format to look nice
   $sec = sprintf("%02d",$sec);
   $min = sprintf("%02d",$min);
   $hour = sprintf("%02d",$hour);
   $mon = sprintf("%02d",$mon+1);
   $mday = sprintf("%02d",$mday);
   $year += 1900;
   my $month = $months[$mon];
   $ltime = "$hour\:$min\:$sec";
   $ldate = "$mon/$mday/$year";
	return ($ltime,$ldate);
}

#======================================================================#
# subroutine my_die
#======================================================================#

sub my_die {

   my($my_mesg, $sys_mesg) = @_;
   print_header();
   print_header_end();

   print qq~
   <html>
   <head>
   <title>$my_mesg</title>
   </head>
   <body bgcolor="#FFFFFF">
   <font face="verdana" size="5"><b>SCRIPT ERROR!!!</b></font>
   <hr>
   <font face="verdana" size="3">
   <b>
   There was an error in processing your request.<br>
   Following is the error message:
   <ul>
   <li>Script Message: $my_mesg
   <li>System Message: $sys_mesg
   </ul>
   <hr>
   Please notify the administrator of this site.
   <p>
   Thank you.
   </b>
   </font>

   </body>
   </html>
   ~;
   exit;       
}

#======================================================================#
# function time_format
#======================================================================#

sub time_format {
   my ($string) = shift;
   my ($hr,$min,$sec) = split(/\:/,$string);
   ($hr,$am_pm) = am_pm($hr);
   $string = join(":",$hr,$min);
   $string .= "&nbsp;" . $am_pm;
   return $string;
}

#======================================================================#
# function date_format
#======================================================================#

sub date_format {
   my ($string) = shift;
   my @months = qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec);
   my ($mon,$day,$year) = split(/\//,$string);
	$year += 1900 if ($year < 101);
   if ($year > 100) {
      $year = substr($year,2,2);
   }
   if ($date_format eq "mmm-dd-yy") {
      $string = join("-",$months[$mon-1],$day,$year);
   }
   elsif ($date_format eq "dd-mmm-yy") {
      $string = join("-",$day,$months[$mon-1],$year);
   }
   elsif ($date_format eq "dd-mm-yy") {
      $string = join("-",$day,$mon,$year);
   }
   elsif ($date_format eq "mm-dd-yy") {
      $string = join("-",$mon,$day,$year);
   }

   return $string;
}

#======================================================================#
# function am_pm
# given hour, print am or pm
#======================================================================#

sub am_pm {
   my ($hour) = shift;
   my $am_pm = 'AM';
   
   if ($hour > 12) {
      $hour -= 12;
      $am_pm = 'PM';
   }
   elsif ($hour == 12) {
      $am_pm = 'PM';
   }

   $hour = sprintf("%02d",$hour);
   return ($hour,$am_pm);
}

#======================================================================#
# function toggle
# for switching back and forth...
#======================================================================#

sub toggle {
   my $reset = shift;
   unless ($reset) {
      if ($style_class eq "lite") {
			$style_class = "dark";
      }
      else {
			$style_class = "lite";
      }
   }
   else {
			$style_class = "lite";
   }
}

#======================================================================#
# function print_header
# print HTTP header if not printed yet
#======================================================================#

sub print_header {

   unless ($print_header) {
      print "Content-type: text/html\n";
      $print_header = 1;
   }
   return 0;
}

#======================================================================#
# function print_header_end
# print end of HTTP header if not printed yet
#======================================================================#

sub print_header_end {
   unless ($print_header_end) {
      print "\n";
      $print_header_end = 1;
   }
}

#===============================================================#
# function form_to_text                                         #
# translates form data to text database format                  #
#===============================================================#

sub form_to_text {
   my $text = shift;
   $text =~ s/"/\&quot\;/g;
   $text =~ s/>/\&gt\;/g;
   $text =~ s/</\&lt\;/g;
   $text =~ s/\n\n/ /g;
   $text =~ s/\r\n/ /g;
   $text =~ s/\n/ /g;
   $text =~ s/\cM//g;
   return $text;
}

#======================================================================#
# sub sort_topics
#======================================================================#

sub sort_topics {

   my ($r_data,$sort_field) = @_;
   my @sorted;

   if ( $sort_field == $view_index) {
		$sort_field--;
      @sorted = map { $_->[0] }
             reverse sort { $a->[1] <=> $b->[1] }
             map { [$_,(split /\|/)[$sort_field] ] } @{$r_data};
   }
	elsif ($sort_field == $id_index) {
		$sort_field--;
      @sorted = map { $_->[0] }
             sort { $a->[1] <=> $b->[1] }
             map { [$_,(split /\|/)[$sort_field] ] } @{$r_data};
	}
	elsif ($sort_field == $vote_index) {
      @sorted = map { $_->[0] }
             reverse sort { $a->[1] <=> $b->[1] }
             map { [$_, votes( (split /\|/)[$rating_index-1] ) ] } @{$r_data};
	}
	elsif ($sort_field == $rating_index) {
		$sort_field--;
      @sorted = map { $_->[0] }
             reverse sort { $a->[1] <=> $b->[1] }
             map { [$_, rating( (split /\|/)[$sort_field] ) ] } @{$r_data};
	}
   else {
		$sort_field--;
      @sorted = map { $_->[0] }
             sort { uc($a->[1]) cmp uc($b->[1]) }
             map { [$_,(split /\|/)[$sort_field] ] } @{$r_data};

   }

   return \@sorted;

}

#======================================================================#
# function rating
#======================================================================#

sub rating {
   my $this = shift;
	my @scores = split(/\,/,$this);
	my $sum = 0;
	my $score = 0;
	if (@scores) {
		my $votes = @scores;
		foreach (@scores) {
			$sum += $_;
		}
		$score = $sum / $votes;
	}
	else {
		$score = "NA";
	}
	return $score;
}

#======================================================================#
# function votes
#======================================================================#

sub votes {
   my $this = shift;
	my @scores = split(/\,/,$this);
	my $votes = @scores;
	return $votes;
}

#======================================================================#
# funciton set_sort_index
# Set sort_index cookie
#======================================================================#

sub set_sort_index {

   my $field = shift;
   send_cookie($sort_by_field_cookie,$field,$expires,"/");

   print_header();
   print_header_end();
   print qq~
   <html>
   <head>
   <META HTTP-EQUIV="Refresh" CONTENT="0; URL=$ENV{'HTTP_REFERER'}">
   </head>
   <body bgolor="#FFFFFF">
   <font size="4" face="verdana" color="#000099">
      <b>Setting your option, please wait...</b></font>
   </body>
   </html>
   ~;
   exit;
}

#======================================================================#
# subroutine sendCookie
# Sends HTTP-COOKIE to the client
#======================================================================#

sub send_cookie {

  my ($key,$value,$expires,$domain) = @_;
  if ($expires ne "") {
      print "Set-Cookie: $key=$value; expires=$expires; path=/; \n";
   }
   else {
      print "Set-Cookie: $key=$value; path=/; \n";
   }

}

#======================================================================#
# subroutine get_cookie
# Get cookie from the client
# Cookie's name is $cookie
#======================================================================#

sub get_cookie {
  my ($cookie) = shift;
  my (@key_value_pairs, $key, $value);
  @key_value_pairs = split (/;\s/, $ENV{'HTTP_COOKIE'});
  foreach (@key_value_pairs) {
    ($key,$value) = split (/=/, $_);
    if ($key eq $cookie) {
      return $value;
    }
  }
  return 0;
}

#======================================================================#
# subroutine update_view
# updates number of views before redirecting
#======================================================================#

sub update_view {

   my $id = shift;
   my $r_data = readdata("$datafile");
	for ($j=0;$j<@{$r_data};$j++) {
	   chomp($r_data->[$j]);
		my @data = split(/\|/,$r_data->[$j]);
		if ($data[0] == $id) {
		   $data[$view_index-1]++;
			$r_data->[$j] = join("\|",@data);
			$r_data->[$j] .= "\n";
			last;
		}
		$r_data->[$j] .= "\n";
	}
	writedata("$datafile",$r_data);

}

#======================================================================#
# subroutine rating_form
# updates user rating
#======================================================================#

sub rating_form {

   my $id = shift;
   my $r_data = readdata("$datafile");
	my @record;
	
	for ($j=0;$j<@{$r_data};$j++) {
	   chomp($r_data->[$j]);
		my @data = split(/\|/,$r_data->[$j]);
		if ($data[0] == $id) {
			@record = @data;
			last;
		}
	}

	$html_output = qq~
	<form method="post">
	<input type="hidden" name="id" value="$id">
	<input type="hidden" name="action" value="update_rating">
	<input type="hidden" name="orig_url" value="$ENV{'HTTP_REFERER'}">
	<table border="0" width="$table_width" cellpadding="5" cellspacing="0">
	<tr class="menu">
	<td class="menu">	<a href="$dcscript">DCLinks Main page</a> > <a href="$ENV{'HTTP_REFERER'}">Previous Page</a></td>
	</tr></table>
	<table border="1" width="$table_width" cellpadding="5" cellspacing="0">
	<tr class="heading">
	<td class="heading" colspan="2">User Rating System</td>
	</tr>
	<tr>
	<td class="dark">ID</td>
	<td class="lite">$record[$field_id{"ID"}]</td>
	</tr>
	<tr>
	<td class="dark">Name</td>
	<td class="lite">$record[$field_id{"Name"}]</td>
	</tr>
	<tr>
	<td class="dark">URL</td>
	<td class="lite">$record[$field_id{"Homepage"}]</td>
	</tr>
	<tr>
	<td class="dark">Description</td>
	<td class="lite">$record[$field_id{"Description"}]</td>
	</tr>
	<tr>
	<td class="dark">Rating</td>
	<td class="lite">
	<select name="score">
	<option>-----Select-----	
	<option value="1">1 - Skip it
	<option value="2">2
	<option value="3">3
	<option value="4">4
	<option value="5">5
	<option value="6">6
	<option value="7">7	
	<option value="8">8
	<option value="9">9
	<option value="10">10 - Really cool
	</select>
	</td>
	</tr>
	<tr>
	<td class="lite" colspan="2"><input type="Submit" value="Submit my rating"></td>
	</tr>
	</table>
	</form>
	~;

}

#======================================================================#
# subroutine update_rating
# updates user rating
#======================================================================#

sub update_rating {

   my ($id,$score) = @_;
   my $r_data = readdata("$datafile");

	for ($j=0;$j<@{$r_data};$j++) {
	   chomp($r_data->[$j]);
		my @data = split(/\|/,$r_data->[$j]);
		if ($data[0] == $id) {
		   my @ratings = split(/\,/,$data[$rating_index-1]);
			push(@ratings,$score);
			$data[$rating_index-1] = join("\,",@ratings);
			$r_data->[$j] = join("\|",@data);
			$r_data->[$j] .= "\n";
			last;
		}
		$r_data->[$j] .= "\n";
	}

	writedata("$datafile",$r_data);

	$html_output = qq~
	<p>Thank you!  You rating has been recorded.
	<br>Now <a href="$in{"orig_url"}">go back to the original page</a>.
	</p>
	~;
}

#======================================================================#
# table_row                                                            #
#======================================================================#

sub table_row {
	my ($field,$type) = @_;
	my $table_row;
	
	if ($type eq "text") {
		$table_row .= qq~
		<tr>
		<td class="dark">
		$field
		</td>
		<td class="lite">
		<input type="$type" name="$field" size="40" value="$in{$field}">
		</td>
		</tr>
		~;
	}
	elsif ($type eq "textarea") {

		$table_row .= qq~
		<tr>
		<td class="dark">
		$field
		</td>
		<td class="lite">
		<textarea name="$field" rows="6" cols="40" wrap="physical">$in{$field}</textarea>
		</td>
		</tr>
		~;
		
	}
	elsif ($type eq "select") {
		my @option_list = eval("@".$field."_list");
		$table_row .= qq~
		<tr>
		<td class="dark">
		$field
		</td>
		<td class="lite">
		<select name="$field">~;
		foreach $option (@option_list) {
			if ($option eq $in{$field}) {
				$table_row .= "<option value=\"$option\" selected>$option\n";
			}
			else {
				$table_row .= "<option value=\"$option\">$option\n";
			}
		}
		
		$table_row .= qq~
		</select>
		</td>
		</tr>
		~;

	}
	else {

		$table_row .= qq~
		<input type="hidden" name="$field" value="$in{$field}">
		~;
	}
	$table_row;
}


# mod.2000.05.23.02
#####
# subroutine readdata
# Sucks in all the data from $datafile
# and returns reference to the data
####

sub readdata {

   my $datafile = shift;
   my $r_data = [];


	# Remove strange characters
	$datafile =~ s/[\||\;\<\>]//g;

   # Get file lock
   lock_file("$datafile.lock");

   if (open(DATA,"$datafile")) {
   	@$r_data = <DATA>;
	   close(DATA);
		unlock_file("$datafile.lock");
	}
	else {
  		unlock_file("$datafile.lock");
		my_die("Error in subroutine readdata: Can't open $datafile",$!);
	}

   return $r_data;

}

# mod.2000.05.23.02
#####
#
# subroutine writedata
#
#####

sub writedata {

   my($datafile,$r_rows) = @_;

	# Remove strange characters
	$datafile =~ s/[\||\;\<\>]//g;

   lock_file("$datafile.lock");

   if (open(DATA,">$datafile")) {
      print DATA @$r_rows;
      close(DATA);
	   chmod(0666,$datafile);
      unlock_file("$datafile.lock");
   }
   else {
      unlock_file("$datafile.lock");
      my_die("Error in subroutine writedata: Can't open $datafile",$!);
   }

}

# mod.2000.05.23.02
#####
#
# subroutine appenddata
#
#
#####

sub appenddata {

   my($datafile,$row) = @_;

	# Remove strange characters
	$datafile =~ s/[\||\;\<\>]//g;

   lock_file("$datafile.lock");

   if (open(DATA,">>$datafile")) {
      print DATA "$row\n";
      close(DATA);
      unlock_file("$datafile.lock");
   }
   else {
      unlock_file("$datafile.lock");
      my_die("Error in subroutine appenddata: Can't open $datafile",$!);
   }
}

# mod.2000.05.23.02
#####
#
# function lock_file
#
# This filelock function is based on Selena Sol's AuthGetFileLock
# The problem with Sol's file lock system is that, at times, the
# file lock would persist, causing the system to pause indifinitely.
# This new function should eliminate this problem
#
#####


sub lock_file {  

    my ($lock_file) = @_;
	 my $flag = 1;
    my $count = 0;

    # check_flock will pause for 3 seconds
    # if the lock file persists for 30 seconds
    # then this routine will delete the lock file
    # and then move on.

    while($flag and $count < 10) {
		$flag = check_flock($lock_file);
      $count++;
    }

    # Did you wait more than a minute - then delete lock file
    # and proceed
    unlink($lock_file) if ($count == 10);
    open(LOCK_FILE, ">$lock_file");    

}


# mod.2000.05.23.02
######
#
# Function unlock_file
#
#####

sub unlock_file {
    my ($lock_file) = @_;
    close(LOCK_FILE);
    unlink($lock_file) if (-e $lock_file);

}

# mod.2000.05.23.02
####
#
# function check_flock
#
# This function checks to see if a file exists
# If it exists, it pauses 5 seconds and the returns 1.
# Otherwise, it returns a 0.
#
# Only one function uses this function - lock_file
#
####

sub check_flock {

   my ($file) = shift;

   if (-e $file) {
      sleep (3);
      return 1;
   }
   else {
      return 0;
   }

}

1;